-----------------------------------------------------------------
--
--   Beispielskript zum Vortrag "Access und SQL Server-Security"
--	 AEK 21 im Oktober 2018
--
--   Autor: Bernd Jungbluth										
--   Keine Gewhrleistung, keine Haftung
--
-----------------------------------------------------------------

USE AEK21;
GO

----------------------------------------------------------
-- Lesezugriff fr Mitglieder der Serverrolle sysadmin
----------------------------------------------------------

-- Verweigern von Rechten fr Vertrieb 
DENY SELECT, INSERT, UPDATE, DELETE ON dbo.Mitarbeiter TO Vertrieb;
GO

-- Lesezugriff als Stromberg
EXECUTE As LOGIN = 'bjSeminare\Stromberg';
SELECT Nachname, Vorname, AktuellesGehalt FROM dbo.Mitarbeiter;
REVERT;
GO
--> Stromberg darf lesen

-- Lesezugriff als Bienlein
EXECUTE As LOGIN = 'bjSeminare\Bienlein';
SELECT Nachname, Vorname, AktuellesGehalt FROM dbo.Mitarbeiter;
REVERT;
GO
--> Bienlein darf nicht lesen

-- Bienlein in Serverrolle sysadmin aufnehmen
EXEC sys.sp_addsrvrolemember 'bjSeminare\Bienlein', 'sysadmin';
GO

-- Lesezugriff als Bienlein
EXECUTE As LOGIN = 'bjSeminare\Bienlein';
SELECT Nachname, Vorname, AktuellesGehalt FROM dbo.Mitarbeiter;
REVERT;
GO
--> Bienlein darf alles - auch lesen


----------------------------------------------------------
-- Aufrumen
----------------------------------------------------------

EXEC sys.sp_dropsrvrolemember 'bjSeminare\Bienlein', 'sysadmin';
GO
REVOKE SELECT, INSERT, UPDATE, DELETE ON dbo.Mitarbeiter TO Vertrieb;
GO